Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_POSIX_Proactor Class Reference

POSIX implementation of the Proactor. More...

`#include <POSIX_Proactor.h>`

Inheritance diagram for ACE_POSIX_Proactor

[legend]
Collaboration diagram for ACE_POSIX_Proactor:

[legend]
List of all members.

## Public Types
enum | Proactor_Type { PROACTOR_POSIX = 0, PROACTOR_AIOCB = 1, PROACTOR_SIG = 2, PROACTOR_SUN = 3 }
enum | SystemType { OS_UNDEFINED = 0x0000, OS_WIN = 0x0100, OS_WIN_NT = OS_WIN | 0x0001, OS_WIN_2000 = OS_WIN | 0x0002, OS_SUN = 0x0200, OS_SUN_55 = OS_SUN | 0x0001, OS_SUN_56 = OS_SUN | 0x0002, OS_SUN_57 = OS_SUN | 0x0004, OS_SUN_58 = OS_SUN | 0x0008, OS_HPUX = 0x0400, OS_HPUX_11 = OS_HPUX | 0x0001, OS_LINUX = 0x0800, OS_FREEBSD = 0x1000 }
## Public Methods
virtual Proactor_Type | get_impl_type (void)
virtual | ~ACE_POSIX_Proactor (void)
| Virtual destructor.
virtual int | close (void)
| Close down the Proactor.
virtual int | register_handle (ACE_HANDLE handle, const void *completion_key)
| This function is a no-op function for Unix systems. Returns 0.
virtual int | post_completion (ACE_POSIX_Asynch_Result *result) = 0
int | wake_up_dispatch_threads (void)
| This is a no-op on POSIX platforms. Returns 0. More...
int | close_dispatch_threads (int wait)
| This is a no-op on POSIX platforms. Returns 0. More...
size_t | number_of_threads (void) const
| This is a no-op on POSIX platforms. Returns 0. More...
void | number_of_threads (size_t threads)
virtual ACE_HANDLE | get_handle (void) const
| This is a no-op in POSIX. Returns ACE_INVALID_HANDLE.
virtual ACE_Asynch_Read_Stream_Result_Impl* | create_asynch_read_stream_result (ACE_Handler &handler, ACE_HANDLE handle, ACE_Message_Block &message_block, u_long bytes_to_read, const void *act, ACE_HANDLE event = ACE_INVALID_HANDLE, int priority = 0, int signal_number = ACE_SIGRTMIN)
| Create the correct implementation class for ACE_Asynch_Read_Stream::Result class.
virtual ACE_Asynch_Write_Stream_Result_Impl* | create_asynch_write_stream_result (ACE_Handler &handler, ACE_HANDLE handle, ACE_Message_Block &message_block, u_long bytes_to_write, const void *act, ACE_HANDLE event = ACE_INVALID_HANDLE, int priority = 0, int signal_number = ACE_SIGRTMIN)
| Create the correct implementation class for ACE_Asynch_Write_Stream::Result.
virtual ACE_Asynch_Read_File_Result_Impl* | create_asynch_read_file_result (ACE_Handler &handler, ACE_HANDLE handle, ACE_Message_Block &message_block, u_long bytes_to_read, const void *act, u_long offset, u_long offset_high, ACE_HANDLE event = ACE_INVALID_HANDLE, int priority = 0, int signal_number = ACE_SIGRTMIN)
| Create the correct implementation class for ACE_Asynch_Read_File::Result.
virtual ACE_Asynch_Write_File_Result_Impl* | create_asynch_write_file_result (ACE_Handler &handler, ACE_HANDLE handle, ACE_Message_Block &message_block, u_long bytes_to_write, const void *act, u_long offset, u_long offset_high, ACE_HANDLE event = ACE_INVALID_HANDLE, int priority = 0, int signal_number = ACE_SIGRTMIN)
| Create the correct implementation class for ACE_Asynch_Write_File::Result.
virtual ACE_Asynch_Read_Dgram_Result_Impl* | create_asynch_read_dgram_result (ACE_Handler &handler, ACE_HANDLE handle, ACE_Message_Block *message_block, size_t bytes_to_read, int flags, int protocol_family, const void* act, ACE_HANDLE event = ACE_INVALID_HANDLE, int priority = 0, int signal_number = ACE_SIGRTMIN)
| Create the correct implementation class for ACE_Asynch_Read_Dgram::Result.
virtual ACE_Asynch_Write_Dgram_Result_Impl* | create_asynch_write_dgram_result (ACE_Handler &handler, ACE_HANDLE handle, ACE_Message_Block *message_block, size_t bytes_to_write, int flags, const void* act, ACE_HANDLE event = ACE_INVALID_HANDLE, int priority = 0, int signal_number = ACE_SIGRTMIN)
| Create the correct implementation class for ACE_Asynch_Write_Dgram::Result.
virtual ACE_Asynch_Accept_Result_Impl* | create_asynch_accept_result (ACE_Handler &handler, ACE_HANDLE listen_handle, ACE_HANDLE accept_handle, ACE_Message_Block &message_block, u_long bytes_to_read, const void *act, ACE_HANDLE event = ACE_INVALID_HANDLE, int priority = 0, int signal_number = ACE_SIGRTMIN)
| Create the correct implementation class for ACE_Asynch_Accept::Result.
virtual ACE_Asynch_Transmit_File_Result_Impl* | create_asynch_transmit_file_result (ACE_Handler &handler, ACE_HANDLE socket, ACE_HANDLE file, ACE_Asynch_Transmit_File::Header_And_Trailer *header_and_trailer, u_long bytes_to_write, u_long offset, u_long offset_high, u_long bytes_per_send, u_long flags, const void *act, ACE_HANDLE event = ACE_INVALID_HANDLE, int priority = 0, int signal_number = ACE_SIGRTMIN)
| Create the correct implementation class for ACE_Asynch_Transmit_File::Result.
virtual ACE_Asynch_Result_Impl* | create_asynch_timer (ACE_Handler &handler, const void *act, const ACE_Time_Value &tv, ACE_HANDLE event = ACE_INVALID_HANDLE, int priority = 0, int signal_number = ACE_SIGRTMIN)
| Create a timer result object which can be used with the Timer mechanism of the Proactor.
## Protected Methods
| ACE_POSIX_Proactor (void)
| Constructor.
void | application_specific_code (ACE_POSIX_Asynch_Result *asynch_result, u_long bytes_transferred, int success, const void *completion_key, u_long error)
virtual int | post_wakeup_completions (int how_many)
## Protected Attributes
ACE_Handler | wakeup_handler_
| Handler to handle the wakeups. This works in conjunction with the .
int | os_id_
## Friends
class | ACE_POSIX_SIG_Asynch_Accept_Handler

## Detailed Description

POSIX implementation of the Proactor.

There are two different strategies by which Proactor can get to know the completion of operations. One is based on Asynchronous I/O Control Blocks (AIOCB) where a list of AIOCBs are stored and completion status of the corresponding operations are queried on them. The other one is based on POSIX Real Time signals. This class abstracts out the common code needed for both the strategies. and specialize this class for each strategy.

## Member Enumeration Documentation

enum ACE_POSIX_Proactor::Proactor_Type

  | Enumeration values:
  PROACTOR_POSIX |
  PROACTOR_AIOCB |
  PROACTOR_SIG |
  PROACTOR_SUN |

enum ACE_POSIX_Proactor::SystemType

  | Enumeration values:
  OS_UNDEFINED |
  OS_WIN |
  OS_WIN_NT |
  OS_WIN_2000 |
  OS_SUN |
  OS_SUN_55 |
  OS_SUN_56 |
  OS_SUN_57 |
  OS_SUN_58 |
  OS_HPUX |
  OS_HPUX_11 |
  OS_LINUX |
  OS_FREEBSD |

## Constructor & Destructor Documentation

ACE_POSIX_Proactor::~ACE_POSIX_Proactor ( | void )`[virtual]`

| Virtual destructor.

ACE_POSIX_Proactor::ACE_POSIX_Proactor ( | void )`[protected]`

| Constructor.

## Member Function Documentation

void ACE_POSIX_Proactor::application_specific_code ( | ACE_POSIX_Asynch_Result * asynch_result,
| u_long bytes_transferred,
| int success,
| const void * completion_key,
| u_long error )`[protected]`

| Protect against structured exceptions caused by user code when dispatching handles. The <completion_key> is not very useful compared to that can be associated each asynchronous operation. <completion_key> is implemented right now for the POSIX Proators. Reimplemented in ACE_POSIX_AIOCB_Proactor.

int ACE_POSIX_Proactor::close ( | void )`[virtual]`

| Close down the Proactor. Reimplemented from ACE_Proactor_Impl.

int ACE_POSIX_Proactor::close_dispatch_threads ( | int wait )`[virtual]`

| This is a no-op on POSIX platforms. Returns 0. @ Reimplemented from ACE_Proactor_Impl.

ACE_Asynch_Accept_Result_Impl * ACE_POSIX_Proactor::create_asynch_accept_result ( | ACE_Handler & handler,
| ACE_HANDLE listen_handle,
| ACE_HANDLE accept_handle,
| ACE_Message_Block & message_block,
| u_long bytes_to_read,
| const void * act,
| ACE_HANDLE event = ACE_INVALID_HANDLE,
| int priority = 0,
| int signal_number = ACE_SIGRTMIN )`[virtual]`

| Create the correct implementation class for ACE_Asynch_Accept::Result. Reimplemented from ACE_Proactor_Impl.

ACE_Asynch_Read_Dgram_Result_Impl * ACE_POSIX_Proactor::create_asynch_read_dgram_result ( | ACE_Handler & handler,
| ACE_HANDLE handle,
| ACE_Message_Block * message_block,
| size_t bytes_to_read,
| int flags,
| int protocol_family,
| const void * act,
| ACE_HANDLE event = ACE_INVALID_HANDLE,
| int priority = 0,
| int signal_number = ACE_SIGRTMIN )`[virtual]`

| Create the correct implementation class for ACE_Asynch_Read_Dgram::Result. Reimplemented from ACE_Proactor_Impl.

ACE_Asynch_Read_File_Result_Impl * ACE_POSIX_Proactor::create_asynch_read_file_result ( | ACE_Handler & handler,
| ACE_HANDLE handle,
| ACE_Message_Block & message_block,
| u_long bytes_to_read,
| const void * act,
| u_long offset,
| u_long offset_high,
| ACE_HANDLE event = ACE_INVALID_HANDLE,
| int priority = 0,
| int signal_number = ACE_SIGRTMIN )`[virtual]`

| Create the correct implementation class for ACE_Asynch_Read_File::Result. Reimplemented from ACE_Proactor_Impl.

ACE_Asynch_Read_Stream_Result_Impl * ACE_POSIX_Proactor::create_asynch_read_stream_result ( | ACE_Handler & handler,
| ACE_HANDLE handle,
| ACE_Message_Block & message_block,
| u_long bytes_to_read,
| const void * act,
| ACE_HANDLE event = ACE_INVALID_HANDLE,
| int priority = 0,
| int signal_number = ACE_SIGRTMIN )`[virtual]`

| Create the correct implementation class for ACE_Asynch_Read_Stream::Result class. Reimplemented from ACE_Proactor_Impl.

ACE_Asynch_Result_Impl * ACE_POSIX_Proactor::create_asynch_timer ( | ACE_Handler & handler,
| const void * act,
| const ACE_Time_Value & tv,
| ACE_HANDLE event = ACE_INVALID_HANDLE,
| int priority = 0,
| int signal_number = ACE_SIGRTMIN )`[virtual]`

| Create a timer result object which can be used with the Timer mechanism of the Proactor. Reimplemented from ACE_Proactor_Impl. Reimplemented in ACE_POSIX_SIG_Proactor.

ACE_Asynch_Transmit_File_Result_Impl * ACE_POSIX_Proactor::create_asynch_transmit_file_result ( | ACE_Handler & handler,
| ACE_HANDLE socket,
| ACE_HANDLE file,
| ACE_Asynch_Transmit_File::Header_And_Trailer * header_and_trailer,
| u_long bytes_to_write,
| u_long offset,
| u_long offset_high,
| u_long bytes_per_send,
| u_long flags,
| const void * act,
| ACE_HANDLE event = ACE_INVALID_HANDLE,
| int priority = 0,
| int signal_number = ACE_SIGRTMIN )`[virtual]`

| Create the correct implementation class for ACE_Asynch_Transmit_File::Result. Reimplemented from ACE_Proactor_Impl.

ACE_Asynch_Write_Dgram_Result_Impl * ACE_POSIX_Proactor::create_asynch_write_dgram_result ( | ACE_Handler & handler,
| ACE_HANDLE handle,
| ACE_Message_Block * message_block,
| size_t bytes_to_write,
| int flags,
| const void * act,
| ACE_HANDLE event = ACE_INVALID_HANDLE,
| int priority = 0,
| int signal_number = ACE_SIGRTMIN )`[virtual]`

| Create the correct implementation class for ACE_Asynch_Write_Dgram::Result. Reimplemented from ACE_Proactor_Impl.

ACE_Asynch_Write_File_Result_Impl * ACE_POSIX_Proactor::create_asynch_write_file_result ( | ACE_Handler & handler,
| ACE_HANDLE handle,
| ACE_Message_Block & message_block,
| u_long bytes_to_write,
| const void * act,
| u_long offset,
| u_long offset_high,
| ACE_HANDLE event = ACE_INVALID_HANDLE,
| int priority = 0,
| int signal_number = ACE_SIGRTMIN )`[virtual]`

| Create the correct implementation class for ACE_Asynch_Write_File::Result. Reimplemented from ACE_Proactor_Impl.

ACE_Asynch_Write_Stream_Result_Impl * ACE_POSIX_Proactor::create_asynch_write_stream_result ( | ACE_Handler & handler,
| ACE_HANDLE handle,
| ACE_Message_Block & message_block,
| u_long bytes_to_write,
| const void * act,
| ACE_HANDLE event = ACE_INVALID_HANDLE,
| int priority = 0,
| int signal_number = ACE_SIGRTMIN )`[virtual]`

| Create the correct implementation class for ACE_Asynch_Write_Stream::Result. Reimplemented from ACE_Proactor_Impl.

ACE_HANDLE ACE_POSIX_Proactor::get_handle ( | void ) const`[virtual]`

| This is a no-op in POSIX. Returns ACE_INVALID_HANDLE. Reimplemented from ACE_Proactor_Impl.

ACE_INLINE ACE_POSIX_Proactor::Proactor_Type ACE_POSIX_Proactor::get_impl_type ( | void )`[virtual]`

| Reimplemented in ACE_POSIX_AIOCB_Proactor, and ACE_POSIX_SIG_Proactor.

void ACE_POSIX_Proactor::number_of_threads ( | size_t threads )`[virtual]`

| Reimplemented from ACE_Proactor_Impl.

size_t ACE_POSIX_Proactor::number_of_threads ( | void ) const`[virtual]`

| This is a no-op on POSIX platforms. Returns 0. @ Reimplemented from ACE_Proactor_Impl.

int ACE_POSIX_Proactor::post_completion ( | ACE_POSIX_Asynch_Result * result )`[pure virtual]`

| Post a result to the completion port of the Proactor. If errors occur, the result will be deleted by this method. If successful, the result will be deleted by the Proactor when the result is removed from the completion port. Therefore, the result should have been dynamically allocated and should be orphaned by the user once this method is called. Reimplemented in ACE_POSIX_AIOCB_Proactor.

int ACE_POSIX_Proactor::post_wakeup_completions ( | int how_many )`[protected, virtual]`

| Post <how_many> completions to the completion port so that all threads can wake up. This is used in conjunction with the <run_event_loop>. Reimplemented from ACE_Proactor_Impl.

int ACE_POSIX_Proactor::register_handle ( | ACE_HANDLE handle,
| const void * completion_key )`[virtual]`

| This function is a no-op function for Unix systems. Returns 0. Reimplemented from ACE_Proactor_Impl.

int ACE_POSIX_Proactor::wake_up_dispatch_threads ( | void )`[virtual]`

| This is a no-op on POSIX platforms. Returns 0. @ Reimplemented from ACE_Proactor_Impl.

## Friends And Related Function Documentation

class ACE_POSIX_SIG_Asynch_Accept_Handler`[friend]`

| For <POSIX_SIG_Asynch_Accept> operation, this handler class does the actual work, has to register the real-time signal with the Proactor.

## Member Data Documentation

int ACE_POSIX_Proactor::os_id_`[protected]`

ACE_Handler ACE_POSIX_Proactor::wakeup_handler_`[protected]`

| Handler to handle the wakeups. This works in conjunction with the .

The documentation for this class was generated from the following files:

- POSIX_Proactor.h
- POSIX_Proactor.cpp
- POSIX_Proactor.i